Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TAO_EC_Conjunction_Filter Class Reference

The conjunction filter. More...

`#include <EC_Conjunction_Filter.h>`

Inheritance diagram for TAO_EC_Conjunction_Filter

[legend]
Collaboration diagram for TAO_EC_Conjunction_Filter:

[legend]
List of all members.

## Public Types
typedef unsigned int | Word
## Public Methods
| TAO_EC_Conjunction_Filter (TAO_EC_Filter* children[], size_t n)
| Constructor. It assumes ownership of both the array and the children.
virtual | ~TAO_EC_Conjunction_Filter (void)
| Destructor.
virtual ChildrenIterator | begin (void) const
virtual ChildrenIterator | end (void) const
virtual int | size (void) const
virtual int | filter (const RtecEventComm::EventSet& event, TAO_EC_QOS_Info& qos_info, CORBA::Environment& env)
virtual int | filter_nocopy (RtecEventComm::EventSet& event, TAO_EC_QOS_Info& qos_info, CORBA::Environment& env)
virtual void | push (const RtecEventComm::EventSet& event, TAO_EC_QOS_Info& qos_info, CORBA::Environment& env)
virtual void | push_nocopy (RtecEventComm::EventSet& event, TAO_EC_QOS_Info& qos_info, CORBA::Environment& env)
virtual void | clear (void)
| Clear any saved state, must reset and assume no events have been received.
virtual CORBA::ULong | max_event_size (void) const
| Returns the maximum size of the events pushed by this filter.
virtual int | can_match (const RtecEventComm::EventHeader& header) const
virtual int | add_dependencies (const RtecEventComm::EventHeader& header, const TAO_EC_QOS_Info &qos_info, CORBA::Environment &ACE_TRY_ENV)
## Private Methods
int | all_received (void) const
| Determine if all the children have received their events.

## Detailed Description

The conjunction filter.

This filter waits until each one of its children has accepted at least one event. Only in that case it accepts and publishes the sequence formed by all the children events.

## Memory Management

It assumes ownership of the children.

## Member Typedef Documentation

typedef unsigned int TAO_EC_Conjunction_Filter::Word

## Constructor & Destructor Documentation

TAO_EC_Conjunction_Filter::TAO_EC_Conjunction_Filter ( | TAO_EC_Filter * children[],
| size_t n )

| Constructor. It assumes ownership of both the array and the children.

TAO_EC_Conjunction_Filter::~TAO_EC_Conjunction_Filter ( | void )`[virtual]`

| Destructor.

## Member Function Documentation

int TAO_EC_Conjunction_Filter::add_dependencies ( | const RtecEventComm::EventHeader & header,
| const TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[virtual]`

| This is used for computing the scheduling dependencies: Leaf filters check if the header could be matched, similar to the can_match() method; if it does they return 1, and 0 otherwise. Intermediate nodes always return 0. This is used to build precise dependencies between the suppliers and the leaf of the filters that accept that event. Notice that only the nodes doing scheduling recurse through the list, so in configurations that do no require scheduling the recursion stops fairly soon. Reimplemented from TAO_EC_Filter.

int TAO_EC_Conjunction_Filter::all_received ( | void ) const`[private]`

| Determine if all the children have received their events.

TAO_EC_Filter::ChildrenIterator TAO_EC_Conjunction_Filter::begin ( | void ) const`[virtual]`

| STL-like iterators Filters follow the Composite pattern. All filters expose the same interface as if they all had children, but for simple filters the iterators return an empty range. Reimplemented from TAO_EC_Filter.

int TAO_EC_Conjunction_Filter::can_match ( | const RtecEventComm::EventHeader & header ) const`[virtual]`

| Returns 0 if an event with that header could never be accepted. This can used by the suppliers to filter out consumers that couldn't possibly be interested in their events. The rt_info and Reimplemented from TAO_EC_Filter.

void TAO_EC_Conjunction_Filter::clear ( | void )`[virtual]`

| Clear any saved state, must reset and assume no events have been received. Reimplemented from TAO_EC_Filter.

TAO_EC_Filter::ChildrenIterator TAO_EC_Conjunction_Filter::end ( | void ) const`[virtual]`

| Reimplemented from TAO_EC_Filter.

int TAO_EC_Conjunction_Filter::filter ( | const RtecEventComm::EventSet & event,
| TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[virtual]`

| Filter this event, returns 1 if the event is accepted, 0 otherwise. Notice that there are two versions of the method, if the event is not const then filter can take ownership of the event. Reimplemented from TAO_EC_Filter.

int TAO_EC_Conjunction_Filter::filter_nocopy ( | RtecEventComm::EventSet & event,
| TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[virtual]`

| Reimplemented from TAO_EC_Filter.

CORBA::ULong TAO_EC_Conjunction_Filter::max_event_size ( | void ) const`[virtual]`

| Returns the maximum size of the events pushed by this filter. Reimplemented from TAO_EC_Filter.

void TAO_EC_Conjunction_Filter::push ( | const RtecEventComm::EventSet & event,
| TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[virtual]`

| This is called by the children when they accept an event and which to pass it up. Notice that there are two versions of the method, if the event is not const then filter can take ownership of the event. Reimplemented from TAO_EC_Filter.

void TAO_EC_Conjunction_Filter::push_nocopy ( | RtecEventComm::EventSet & event,
| TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[virtual]`

| Reimplemented from TAO_EC_Filter.

int TAO_EC_Conjunction_Filter::size ( | void ) const`[virtual]`

| Reimplemented from TAO_EC_Filter.

The documentation for this class was generated from the following files:

- EC_Conjunction_Filter.h
- EC_Conjunction_Filter.cpp